#include "tools.h"

int main(int argc,char **argv)
{
	int i;
	File	= BUREAU;
	factor	= 1;
	bordure = 60;
	seuil = 2*sqrt(2);
	nbpoints = 2;
	partition = 9;
	Trackmode = TRACKV4;
	Arguments(&argc,argv);
	/* Chargement des images */
	image[LEFT0].img  = ImageLoad(Name[File][LEFT]);
	image[RIGHT0].img = ImageLoad(Name[File][RIGHT]);
	image[LEFT1].img  = ImageLoad(Name[File][LEFT]);
	image[RIGHT1].img = ImageLoad(Name[File][RIGHT]);
	for(i=0;i<4;i++)
		if(image[i].img==NULL)
			printf("erreur de lecture du fichier %d\n",i);
	/* Changement de rsolution */
	image[LEFT0].img  = Resolution(image[LEFT0].img	, factor);
	image[RIGHT0].img = Resolution(image[RIGHT0].img, factor);
	image[LEFT1].img  = Resolution(image[LEFT1].img	, factor);
	image[RIGHT1].img = Resolution(image[RIGHT1].img, factor);
	/* Initilisation des dimensions */
	TailleXtrack = format[R800_600][X];
	TailleYtrack = format[R800_600][Y];
	TailleXscan  = format[R800_600][X];
	TailleYscan  = format[R800_600][Y]/2;
	TailleXredr  = format[R800_600][X];
	TailleYredr  = format[R800_600][Y]/2;
	Height = image[LEFT0].img->height;
	Width  = image[LEFT0].img->width;
	/* Initialisation des critres du tracker */
	for(i=0;i<4;i++)
	{
		image[i].tracker = malloc(sizeof(Tracker));
		InitCriteria(image[i].tracker);
	}
	TrackProcess(Trackmode);
	if(Mode==TEXTE)
		return 0;


	/* Cration OpenGL */
	glutInit(&argc, argv);  
	/* OpenGL */
		/* Troisime fentre Redressement */
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);  
	glutInitWindowSize(TailleXredr,TailleYredr);
	glutInitWindowPosition(5,TailleYredr-TailleYredr+50);  
	Handle_Redresse = glutCreateWindow("OpenGL - OpenCV - Redressement.....");  
	glutDisplayFunc(displayRedressement); 
	glutReshapeFunc(reshapeRedressement);
	glutPassiveMotionFunc(mousePassiveMotionRedre);
	glutKeyboardFunc(clavier);
		/* Seconde fentre Scanline */
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);  
	glutInitWindowSize(TailleXscan,TailleYscan);
	glutInitWindowPosition(5,TailleYtrack+50);  
	Handle_Scanline = glutCreateWindow("OpenGL - OpenCV - Scanline.....");  
	glutDisplayFunc(displayScanline); 
	glutReshapeFunc(reshapeScanline);
	glutKeyboardFunc(clavier);
		/* Premier fentre Tracking */
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);  
	glutInitWindowPosition(0,0);  
	glutInitWindowSize(TailleXtrack+bordure,TailleYtrack);
	Handle_Tracking = glutCreateWindow("OpenGL - OpenCV - Tracking.....");  
	glutDisplayFunc(display);  
	glutReshapeFunc(reshape);
	glutIdleFunc(Idle);
	glutKeyboardFunc(clavier);
	glutMouseFunc(mouse);
	glutMotionFunc(mouseMove);
	glutPassiveMotionFunc(mousePassiveMotion);
	glutMainLoop();  
	return 0;
}
